// Watcom includes
#include <fstream.h>
#include <strstream.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

// Z2 includes
#include "global.h"
#include "kernel.h"
#include "compiler.h"

char *commands[CMD] =
{
  "Z2Omega",
  "Ask",                               // 1
  "BarkFont",                          // 2
  "BarkColor",                         // 3
  "Become",                            // 4
  "Bind",                              // 5
  "Breakable",                         // 6
  "CamXY",                             // 7
  "CamFocus",                          // 8
  "CamShake",                          // 9
  "Cam",                               // 10
  "Ceiling",                           // 11
  "Change",                            // 12
  "CopyXY",                            // 13
  "Copy",                              // 14
  "CycleP",                            // 15
  "Cycle",                             // 16
  "DecR",                              // 17
  "Dec",                               // 18
  "DieItem",                           // 19
  "Die",                               // 20
  "DupeXY",                            // 21
  "Dupe",                              // 22
  "EndGame",                           // 23
  "End",                               // 24
  "FadeIn",                            // 25
  "FadeOut",                           // 26
  "Floor",                             // 27
  "FrameP",                            // 28
  "Frame",                             // 29
  "Give",                              // 30
  "Goto",                              // 31
  "Go",                                // 32
  "Idle",                              // 33
  "IfXY",                              // 34
  "IfRel",                             // 35
  "IfNotXY",                           // 36
  "IfNotRel",                          // 37
  "IfAny",                             // 38
  "IfNo",                              // 39
  "IfAlignedNS",                       // 40
  "IfAlignedEW",                       // 41
  "IfAligned",                         // 42
  "IfBlocked",                         // 43
  "IfContact",                         // 44
  "IfLastShot",                        // 45
  "IfLastTouch",                       // 46
  "IfSwimming",                        // 47
  "IfTouching",                        // 48
  "IfWalking",                         // 49
  "If",                                // 50
  "IncR",                              // 51
  "Inc",                               // 52
  "Input",                             // 53
  "Laser",                             // 54
  "LightTorch",                        // 58
  "LockpNS",                           // 59
  "LockpEW",                           // 60
  "LockpAttack",                       // 61
  "Lockp",                             // 62
  "Lock",                              // 63
  "Loop",                              // 64
  "ModFadeIn",                         // 65
  "ModFadeOut",                        // 66
  "ModKill",                           // 67
  "ModLoad",                           // 68
  "ModNext",                           // 69
  "ModPat",                            // 70
  "ModPrev",                           // 71
  "ModStart",                          // 72
  "ModStop",                           // 73
  "ModVolume",                         // 74
  "MoveXY",                            // 75
  "Move",                              // 76
  "MsgFont",                           // 77
  "MsgColor",                          // 78
  "MsgXY",                             // 79
  "Object",                            // 80
  "PlayFile",                          // 81
  "PlayKill",                          // 82
  "PlayLoad",                          // 83
  "PlaySet",                           // 84
  "Play",                              // 85
  "Pushable",                          // 86
  "Restart",                           // 87
  "Restore",                           // 88
  "RotateCW",                          // 89
  "RotateCCW",                         // 90
  "SendRelP",                          // 91
  "SendRel",                           // 92
  "SendXY",                            // 93
  "Send",                              // 94
  "SetR",                              // 95
  "Set",                               // 96
  "Shoot",                             // 97
  "Solid",                             // 98
  "SpawnRelP",                         // 99
  "SpawnXY",                           // 100
  "Spawn",                             // 101
  "StrCmp",                            // 102
  "StriCmp",                           // 103
  "StrWord",                           // 104
  "SwapXY",                            // 105
  "Swap",                              // 106
  "SwimmerP",                          // 107
  "Swimmer",                           // 108
  "Take",                              // 109
  "TeleportXY",                        // 110
  "Teleport",                          // 111
  "TileUp",                            // 112
  "TileDown",                          // 113
  "TileLeft",                          // 114
  "TileRight",                         // 115
  "TileFlipV",                         // 116
  "TileFlipH",                         // 117
  "TileRotateL",                       // 118
  "TileRotateR",                       // 119
  "Try",                               // 120
  "Unlockp",                           // 121
  "Unlock",                            // 122
  "Walk",                              // 123
  "Zap"                                // 124
};

// c = coords (4,3)
// d = direction (n,e,rndp ne)
// e = operand (==,!=,<=,etc...)
// l = label/message
// o = object name (DumbObj)
// r = range (1-9)
// s = string ("String")
// v = variable (!xxx)
// # = number (45, 'd', !xxx)
// 1 = number, 1=default

char *params[CMD] =
{
  "",                                  // 0
  "s",                                 // #Ask
  "#",                                 // #BarkFont
  "#",                                 // #BarkColor
  "o",                                 // #Become
  "o",                                 // #Bind
  "#",                                 // #Breakable
  "c",                                 // #CamXY
  "o",                                 // #CamFocus
  "##",                                // #CamShake
  "d1",                                // #Cam
  "#",                                 // #Ceiling
  "oo",                                // #Change
  "cc",                                // #CopyXY
  "dd",                                // #Copy
  "#",                                 // #CycleP
  "#",                                 // #Cycle
  "vr",                                // #DecR
  "v1",                                // #Dec
  "",                                  // #DieItem
  "",                                  // #Die
  "c",                                 // #DupeXY
  "d",                                 // #Dupe
  "",                                  // #EndGame
  "",                                  // #End
  "",                                  // #FadeIn
  "",                                  // #FadeOut
  "#",                                 // #Floor
  "#",                                 // #FrameP
  "#",                                 // #Frame
  "v1",                                // #Give
  "l",                                 // #Goto
  "d",                                 // #Go
  "",                                  // #Idle
  "col",                               // #IfXY
  "dol",                               // #IfRel
  "col",                               // #IfNotXY
  "dol",                               // #IfNotRel
  "ol",                                // #IfAny
  "ol",                                // #IfNo
  "dol",                               // #IfAlignedNS
  "dol",                               // #IfAlignedEW
  "dol",                               // #IfAligned
  "ol",                                // #IfBlocked
  "dol",                               // #IfContact
  "dol",                               // #IfLastShot
  "dol",                               // #IfLastTouch
  "dol",                               // #IfSwimming
  "dol",                               // #IfTouching
  "dol",                               // #IfWalking
  "ve#l",                              // #If
  "vr",                                // #IncR
  "v1",                                // #Inc
  "s",                                 // #Input
  "d#",                                // #Laser
  "",                                  // #LightTorch
  "",                                  // #LockPNS
  "",                                  // #LockPEW
  "",                                  // #LockPAttack
  "",                                  // #LockP
  "",                                  // #Lock
  "vl",                                // #Loop
  "s",                                 // #ModFadeIn
  "",                                  // #ModFadeOut
  "",                                  // #ModKill
  "s",                                 // #ModLoad
  "",                                  // #ModNext
  "",                                  // #ModPat
  "",                                  // #ModPrev
  "",                                  // #ModStart
  "",                                  // #ModStop
  "#",                                 // #ModVolume
  "cl",                                // #MoveXY
  "dl",                                // #Move
  "#",                                 // #MsgFont
  "#",                                 // #MsgColor
  "c",                                 // #MsgXY
  "#",                                 // #Object
  "s",                                 // #PlayFile
  "#",                                 // #PlayKill
  "sv",                                // #PlayLoad
  "####",                              // #PlaySet
  "#",                                 // #Play
  "#",                                 // #Pushable
  "",                                  // #Restart
  "l",                                 // #Restore
  "",                                  // #RotateCW
  "",                                  // #RotateCCW
  "dl",                                // #SendRelP
  "dl",                                // #SendRel
  "cl",                                // #SendXY
  "ol",                                // #Send
  "vr",                                // #SetR
  "v#",                                // #Set
  "d",                                 // #Shoot
  "#",                                 // #Solid
  "od",                                // #SpawnRelP
  "oc",                                // #SpawnXY
  "od",                                // #Spawn
  "sl",                                // #StrCmp
  "sl",                                // #StriCmp
  "sl",                                // #StrWord
  "cc",                                // #SwapXY
  "dd",                                // #Swap
  "#",                                 // #SwimmerP
  "#",                                 // #Swimmer
  "v#l",                               // #Take
  "c",                                 // #TeleportXY
  "d",                                 // #Teleport
  "#",                                 // #TileUp
  "#",                                 // #TileDown
  "#",                                 // #TileLeft
  "#",                                 // #TileRight
  "#",                                 // #TileFlipV
  "#",                                 // #TileFlipH
  "#",                                 // #TileRotateL
  "#",                                 // #TileRotateR
  "dl",                                // #Try
  "",                                  // #Unlockp
  "",                                  // #Unlock
  "d",                                 // #Walk
  "l"                                  // #Zap
};

#define EOC_NO      0
#define EOC_YES     1

char EOC[CMD] =    // end-of-cycle
{
  EOC_NO,                         // 0
  EOC_YES,                        // #Ask
  EOC_YES,                        // #BarkFont
  EOC_YES,                        // #BarkColor
  EOC_YES,                        // #Become
  EOC_NO,                         // #Bind
  EOC_NO,                         // #Breakable
  EOC_YES,                        // #CamXY
  EOC_YES,                        // #CamFocus
  EOC_YES,                        // #CamShake
  EOC_YES,                        // #Cam
  EOC_YES,                        // #Ceiling
  EOC_YES,                        // #Change
  EOC_YES,                        // #CopyXY
  EOC_YES,                        // #Copy
  EOC_NO,                         // #CycleP
  EOC_NO,                         // #Cycle
  EOC_NO,                         // #DecR
  EOC_NO,                         // #Dec
  EOC_YES,                        // #DieItem
  EOC_YES,                        // #Die
  EOC_YES,                        // #DupeXY
  EOC_YES,                        // #Dupe
  EOC_NO,                         // #EndGame
  EOC_YES,                        // #End
  EOC_NO,                         // #FadeIn
  EOC_NO,                         // #FadeOut
  EOC_YES,                        // #Floor
  EOC_YES,                        // #FrameP
  EOC_YES,                        // #Frame
  EOC_NO,                         // #Give
  EOC_NO,                         // #Goto
  EOC_YES,                        // #Go
  EOC_YES,                        // #Idle
  EOC_NO,                         // #IfXY
  EOC_NO,                         // #IfRel
  EOC_NO,                         // #IfNotXY
  EOC_NO,                         // #IfNotRel
  EOC_NO,                         // #IfAny
  EOC_NO,                         // #IfNo
  EOC_NO,                         // #IfAlignedNS
  EOC_NO,                         // #IfAlignedEW
  EOC_NO,                         // #IfAligned
  EOC_NO,                         // #IfBlocked
  EOC_NO,                         // #IfContact
  EOC_NO,                         // #IfLastShot
  EOC_NO,                         // #IfLastTouch
  EOC_NO,                         // #IfSwimming
  EOC_NO,                         // #IfTouching
  EOC_NO,                         // #IfWalking
  EOC_NO,                         // #If
  EOC_NO,                         // #IncR
  EOC_NO,                         // #Inc
  EOC_YES,                        // #Input
  EOC_YES,                        // #Laser
  EOC_YES,                        // #LightTorch
  EOC_NO,                         // #LockPNS
  EOC_NO,                         // #LockPEW
  EOC_NO,                         // #LockPAttack
  EOC_NO,                         // #LockP
  EOC_NO,                         // #Lock
  EOC_NO,                         // #Loop
  EOC_NO,                         // #ModFadeIn
  EOC_NO,                         // #ModFadeOut
  EOC_NO,                         // #ModKill
  EOC_NO,                         // #ModLoad
  EOC_NO,                         // #ModNext
  EOC_NO,                         // #ModPat
  EOC_NO,                         // #ModPrev
  EOC_NO,                         // #ModStart
  EOC_NO,                         // #ModStop
  EOC_NO,                         // #ModVolume
  EOC_YES,                        // #MoveXY
  EOC_YES,                        // #Move
  EOC_YES,                        // #MsgFont
  EOC_YES,                        // #MsgColor
  EOC_YES,                        // #MsgXY
  EOC_YES,                        // #Object
  EOC_NO,                         // #PlayFile
  EOC_NO,                         // #PlayKill
  EOC_NO,                         // #PlayLoad
  EOC_NO,                         // #PlaySet
  EOC_NO,                         // #Play
  EOC_YES,                        // #Pushable
  EOC_NO,                         // #Restart
  EOC_NO,                         // #Restore
  EOC_NO,                         // #RotateCW
  EOC_NO,                         // #RotateCCW
  EOC_YES,                        // #SendRelP
  EOC_YES,                        // #SendRel
  EOC_YES,                        // #SendXY
  EOC_NO,                         // #Send
  EOC_NO,                         // #SetR
  EOC_NO,                         // #Set
  EOC_YES,                        // #Shoot
  EOC_YES,                        // #Solid
  EOC_YES,                        // #SpawnRelP
  EOC_YES,                        // #SpawnXY
  EOC_YES,                        // #Spawn
  EOC_NO,                         // #StrCmp
  EOC_NO,                         // #StriCmp
  EOC_NO,                         // #StrWord
  EOC_YES,                        // #SwapXY
  EOC_YES,                        // #Swap
  EOC_YES,                        // #SwimmerP
  EOC_YES,                        // #Swimmer
  EOC_NO,                         // #Take
  EOC_YES,                        // #TeleportXY
  EOC_YES,                        // #Teleport
  EOC_YES,                        // #TileUp
  EOC_YES,                        // #TileDown
  EOC_YES,                        // #TileLeft
  EOC_YES,                        // #TileRight
  EOC_YES,                        // #TileFlipV
  EOC_YES,                        // #TileFlipH
  EOC_YES,                        // #TileRotateL
  EOC_YES,                        // #TileRotateR
  EOC_YES,                        // #Try
  EOC_NO,                         // #Unlockp
  EOC_NO,                         // #Unlock
  EOC_NO,                         // #Walk
  0                               // #Zap
};

int ReadText(char *code, int maxlen)
{
  char *str = new char[maxlen+1];
  int len;

  strncpy(str, strtok(NULL, " "), maxlen);
  len = strlen(str);
  xor(str);
  strcpy(code, str);
  strcat(code, "/0");

  delete[] str;

  return len+1;
}

int Parse(char *line, char *code)
{
  char *temp, *buf, *ctemp;
  char *command;
  ushort x, y, z;
  char i;
  int j, len=0, dir=0;
  int param=0, count;

  temp = new char[256];

  for (i=0; i<CMD; i++)
  {
    int size = strlen(commands[i]);
    if (strnicmp(line, commands[i], size)==0)
    {
      code[len++] = i;
      //read params
      if (strlen(params[i])>0)
      {
        strcpy(temp, line);
        strtok(temp, " ");
        for (j=0; j<strlen(params[i]); j++)
        {
          switch (params[i][j])
          {
            case 'c' : // coords
              // get x
              ctemp = strtok(NULL, " ");
              count = 0;
              while (*ctemp++) if (*ctemp==',') count++;
              strcpy(temp, line);
              strtok(temp, " ");

              buf = strtok(NULL, ",");
              x = (ushort)strtol(buf, NULL, 0);

              // get y
              buf = strtok(NULL, ", ");
              y = (ushort)strtol(buf, NULL, 0);

              if (count==2)
              {
                // get z
                buf = strtok(NULL, " ");
                z = (ushort)strtol(buf, NULL, 0);
              } else z = 0;

              memcpy(code+len, (char *)&x, sizeof(ushort));
              len += 2;
              memcpy(code+len, (char *)&y, sizeof(ushort));
              len += 2;
              memcpy(code+len, (char *)&z, sizeof(ushort));
              len += 2;
              break;
            case 'd' : // direction
              dir=0;

              // read first part (may be modifier or direction)
              buf = strtok(NULL, " ");

              // check for modifiers
              if (stricmp(buf, "cw")==0)   dir = 0x20;     // clockwise
              if (stricmp(buf, "ccw")==0)  dir = 0x40;     // counterclockwise
              if (stricmp(buf, "opp")==0)  dir = 0x60;     // opposite
              if (stricmp(buf, "rndp")==0) dir = 0x80;     // rnd perp.

              // if a modifier, read second part
              if (dir>0) buf = strtok(NULL, " ");

              if (stricmp(buf, "n")==0 ||         // north
                  stricmp(buf, "north")==0 ||
                  stricmp(buf, "up")==0)          dir += GO_NORTH;
              if (stricmp(buf, "s")==0 ||         // south
                  stricmp(buf, "south")==0 ||
                  stricmp(buf, "down")==0)        dir += GO_SOUTH;
              if (stricmp(buf, "e")==0 ||         // east
                  stricmp(buf, "east")==0 ||
                  stricmp(buf, "right")==0)       dir += GO_EAST;
              if (stricmp(buf, "w")==0 ||         // west
                  stricmp(buf, "west")==0 ||
                  stricmp(buf, "left")==0)        dir += GO_WEST;
              if (stricmp(buf, "r")==0 ||         // random
                  stricmp(buf, "rnd")==0)         dir += 0x0A;
              if (stricmp(buf, "rns")==0 ||       // random n/s
                  stricmp(buf, "rndns")==0)       dir += 0x0B;
              if (stricmp(buf, "rew")==0 ||       // random e/w
                  stricmp(buf, "rndew")==0)       dir += 0x0C;
              if (stricmp(buf, "rnb")==0 ||       // random nb
                  stricmp(buf, "rndnb")==0)       dir += 0x0D;
              if (stricmp(buf, "rb")==0 ||        // random b
                  stricmp(buf, "rndb")==0)        dir += 0x0E;
              if (stricmp(buf, "seek")==0)        // player dir
                  dir += 0x10;
              if (stricmp(buf, "f")==0 ||         // current dir
                  stricmp(buf, "flow")==0)        dir += 0x11;
              if (stricmp(buf, "i")==0 ||         // idle
                  stricmp(buf, "idle")==0)        dir = 0x12;

              code[len++] = dir;
              break;
            case 'e' : // operand
              dir=0;

              // read first part
              buf = strtok(NULL, " ");

              // parse operands
              if (stricmp(buf, "==")==0 ||
                  stricmp(buf, "=")==0)           dir = 0x01;
              if (stricmp(buf, "!=")==0 ||
                  stricmp(buf, "<>")==0)          dir = 0x02;
              if (stricmp(buf, "<=")==0 ||
                  stricmp(buf, "=<")==0)          dir = 0x03;
              if (stricmp(buf, ">=")==0 ||
                  stricmp(buf, "=>")==0)          dir = 0x04;
              if (stricmp(buf, "<")==0)           dir = 0x05;
              if (stricmp(buf, ">")==0)           dir = 0x06;

              code[len++] = dir;
              break;
            case 'l' : // label
              // get label
              buf = strtok(NULL, " ");
              memcpy(code+len, buf, strlen(buf));
              len += strlen(buf);
              code[len++] = 0;
              break;
            case 'o' : // object name
              // get objname
              buf = strtok(NULL, " ");
              memcpy(code+len, buf, strlen(buf));
              len += strlen(buf);
              code[len++] = 0;
              break;
            case 'r' : // range
              // get min
              buf = strtok(NULL, "-");
              if (buf[0]=='!')
              {
                memcpy(code+len, buf, strlen(buf));
                len += strlen(buf);
                code[len++] = 0;
              } else
              {
                x = (ushort)strtol(buf, NULL, 0);
                memcpy(code+len, (char *)&x, sizeof(ushort));
                len += sizeof(ushort);
              }
              // get max
              buf = strtok(NULL, " ");
              if (buf[0]=='!')
              {
                memcpy(code+len, buf, strlen(buf));
                len += strlen(buf);
                code[len++] = 0;
              } else
              {
                y = (ushort)strtol(buf, NULL, 0);
                memcpy(code+len, (char *)&y, sizeof(ushort));
                len += sizeof(ushort);
              }
              break;
            case 's' : // string
              // get string
              buf = strtok(NULL, "\"");
              memcpy(code+len, buf, strlen(buf));
              len += strlen(buf);
              code[len++] = 0;
              break;
            case 'v' : // variable
              // get variable
              buf = strtok(NULL, " ");
              memcpy(code+len, buf, strlen(buf));
              len += strlen(buf);
              code[len++] = 0;
              break;
            case '#' : // number
              // get num
              buf = strtok(NULL, " ");
              if (buf[0]=='!')         // if a variable, copy name
              {
                memcpy(code+len, buf, strlen(buf));
                len += strlen(buf);
                code[len++] = 0;
              } else
              {
                x = (ushort)strtol(buf, NULL, 10);
                memcpy(code+len, (char *)&x, sizeof(ushort));
                len += sizeof(ushort);
              }
              break;
            case '1' : // number, def=1
              // get num
              buf = strtok(NULL, " ");
              if (!buf)
              {
                x = 1;
                memcpy(code+len, (char *)&x, sizeof(ushort));
                len += sizeof(ushort);
              } else
              {
                if (buf[0]=='!')         // if a variable, copy name
                {
                  memcpy(code+len, buf, strlen(buf));
                  len += strlen(buf);
                  code[len++] = 0;
                } else
                {
                  x = (ushort)strtol(buf, NULL, 10);
                  memcpy(code+len, (char *)&x, sizeof(ushort));
                  len += sizeof(ushort);
                }
              }
              break;
          }
        }
      }
      break;
    }
  }

  delete[] temp;
  if (i==CMD) return -1;
  return len;
}

int Compile(char *scrfile, char *dest)
{
  char *line, *text, *name, *code;
  char Descriptor;
  int  length, intext, i;
  int  totlines=0;
  short hash;

  // get files ready for compiling
  ifstream scr(scrfile);
  if (!scr) return 0;
  ofstream obj(dest, ios::out | ios::binary);
  if (!obj) return 0;

  // write identification code
  obj.write(ZZTVersion, 4);

  // allocate memory
  name = new char[OBJNAME_MAX];
  if (!name) return 0;
  code = new char[1024];
  if (!code) return 0;
  line = new char[SCRATCH_SIZE];
  if (!line) return 0;

  while (scr.getline(line, SCRATCH_SIZE))
  {
    totlines++;
    Descriptor = line[0];
//    printf("\rCompiling line %d...", totlines);

    switch (Descriptor)
    {
      case '@' : // Object name
        intext = 0;
        obj.put((char)ObjNameOp);
        strncpy(name, &line[1], OBJNAME_MAX);
        xor(name);
        obj.write(name, strlen(name));
        obj.put((char)NULL);
        break;
      case '/' : // Movement
        intext = 0;
        text = line+1;
        xor(text);
        obj.put((char)MoveOp);
        obj.write(text, strlen(text));
        obj.put((char)NULL);
        break;
      case '>' : // persistent #Go
        intext = 0;
        text = line+1;
        xor(text);
        obj.put((char)PersgoOp);
        obj.write(text, strlen(text));
        obj.put((char)NULL);
        break;
      case '<' : // camera pan
        intext = 0;
        text = line+1;
        xor(text);
        obj.put((char)CamOp);
        obj.write(text, strlen(text));
        obj.put((char)NULL);
        break;
      case '#' : // Command
        intext = 0;
        obj.put((char)CommandOp);
        for (i=0; i<strlen(line); i++)
          if (line[i]==';') line[i] = 0;
        length = Parse(&line[1], code);
        if (length>0)
        {
          obj.write(code, length);
          obj.put((char)NULL);
        } else
        {
          scr.close();
          obj.close();

          delete[] name;
          delete[] code;
          delete[] line;

          switch (length)
          {
            case 0:
              g_Done();
              printf("\nError compiling!");
              exit(1);
            case -1:
              g_Done();
              printf("\nUnknown command in line %d!", totlines);
              exit(1);
          }
        }

        break;
      case ':' : // Label
        strncpy(name, &line[1], LABEL_MAX);
        obj.put((char)LabelOp);
        xor(name);
        obj.write(name, strlen(name));
        obj.put((char)NULL);
        break;
      case '|' : // Zapped Label
        strncpy(name, &line[1], LABEL_MAX);
        obj.put((char)ZapLabelOp);
        xor(name);
        obj.write(name, strlen(name));
        obj.put((char)NULL);
        break;
      case '?' : case '!' : // Interaction
        intext = 1;
        char *codebackup;
        codebackup = code;

        strcpy(codebackup, strchr(line, ';'));
        name = strtok(&line[1], ";");
        hash = Hash(name);
        obj.put((char)InterOp);
        obj.write((unsigned char*)&hash, sizeof(short));

        xor(codebackup);
        codebackup++;
        obj.write(codebackup, strlen(codebackup));
        obj.put((char)NULL);
        break;
      case '$' : // Centered text
        intext = 1;
        text = line+1;
        xor(text);
        obj.put((char)CenTextOp);
        obj.write(text, strlen(text));
        obj.put((char)NULL);
        break;
      case ']' : // Bark
        intext = 1;
        text = line+1;
        xor(text);
        obj.put((char)BarkOp);
        obj.write(text, strlen(text));
        obj.put((char)NULL);
        break;
      case '[' : // Player Bark
        intext = 1;
        text = line+1;
        xor(text);
        obj.put((char)PBarkOp);
        obj.write(text, strlen(text));
        obj.put((char)NULL);
        break;
      case '}' : // Message
        intext = 1;
        text = line+1;
        xor(text);
        obj.put((char)MessageOp);
        obj.write(text, strlen(text));
        obj.put((char)NULL);
        break;
      case '{' : // Mono-Space Message
        intext = 1;
        text = line+1;
        xor(text);
        obj.put((char)MSMessageOp);
        obj.write(text, strlen(text));
        obj.put((char)NULL);
        break;
      case ';' : case '`' : // Comment
        intext = 1;
        text = line+1;
        xor(text);
        obj.put((char)CommentOp);
        obj.write(text, strlen(text));
        obj.put((char)NULL);
        break;
      default :
        if (strlen(line))
        {
          intext = 1;
          text   = line;
          xor(text);
          obj.put((char)TextOp);
          obj.write(text, strlen(text));
          obj.put((char)NULL);
        } else
        {
          if (intext)
          {
            obj.put((char)TextOp);
            obj.put((char)NULL);
          } else
          {
            obj.put((char)BreakOp);
            obj.put((char)NULL);
          }
        }
        break;
    }
  }

  scr.close();
  obj.close();

  delete[] name;
  delete[] code;
  delete[] line;

  return 1;
}

int CompileMem(char *scrfile, char *dest)
{
  char *line, *text, *name, *code;
  char Descriptor;
  int  length, intext, i;
  int  totlines=0;
  short hash;

  // get files ready for compiling
  istrstream scr(scrfile);
  if (!scr) return 0;
  ostrstream obj(dest, SCRATCH_SIZE);
  if (!obj) return 0;

  // write identification code
//  obj.write(ZZTVersion, 4);

  // allocate memory
  name = new char[OBJNAME_MAX];
  if (!name) return 0;
  code = new char[1024];
  if (!code) return 0;
  line = new char[SCRATCH_SIZE];
  if (!line) return 0;

  while (scr.getline(line, SCRATCH_SIZE))
  {
    totlines++;
    Descriptor = line[0];
//    printf("\rCompiling line %d...", totlines);

    switch (Descriptor)
    {
      case '@' : // Object name
        intext = 0;
        obj.put((char)ObjNameOp);
        strncpy(name, &line[1], OBJNAME_MAX);
        xor(name);
        obj.write(name, strlen(name));
        obj.put((char)NULL);
        break;
      case '/' : // Movement
        intext = 0;
        text = line+1;
        xor(text);
        obj.put((char)MoveOp);
        obj.write(text, strlen(text));
        obj.put((char)NULL);
        break;
      case '>' : // persistent #Go
        intext = 0;
        text = line+1;
        xor(text);
        obj.put((char)PersgoOp);
        obj.write(text, strlen(text));
        obj.put((char)NULL);
        break;
      case '<' : // camera pan
        intext = 0;
        text = line+1;
        xor(text);
        obj.put((char)CamOp);
        obj.write(text, strlen(text));
        obj.put((char)NULL);
        break;
      case '#' : // Command
        intext = 0;
        obj.put((char)CommandOp);
        for (i=0; i<strlen(line); i++)
          if (line[i]==';') line[i] = 0;
        length = Parse(&line[1], code);
        if (length>0)
        {
          obj.write(code, length);
          obj.put((char)NULL);
        } else
        {
          delete[] name;
          delete[] code;
          delete[] line;

          return length*totlines;      // length=0, return 0
                                       // length=-1, return -13 (line #)
        }

        break;
      case ':' : // Label
        strncpy(name, &line[1], LABEL_MAX);
        obj.put((char)LabelOp);
        xor(name);
        obj.write(name, strlen(name));
        obj.put((char)NULL);
        break;
      case '|' : // Zapped Label
        strncpy(name, &line[1], LABEL_MAX);
        obj.put((char)ZapLabelOp);
        xor(name);
        obj.write(name, strlen(name));
        obj.put((char)NULL);
        break;
      case '?' : case '!' : // Interaction
        intext = 1;
        char *codebackup;
        codebackup = code;

        strcpy(codebackup, strchr(line, ';'));
        name = strtok(&line[1], ";");
        hash = Hash(name);
        obj.put((char)InterOp);
        obj.write((unsigned char*)&hash, sizeof(short));

        xor(codebackup);
        codebackup++;
        obj.write(codebackup, strlen(codebackup));
        obj.put((char)NULL);
        break;
      case '$' : // Centered text
        intext = 1;
        text = line+1;
        xor(text);
        obj.put((char)CenTextOp);
        obj.write(text, strlen(text));
        obj.put((char)NULL);
        break;
      case ']' : // Bark
        intext = 1;
        text = line+1;
        xor(text);
        obj.put((char)BarkOp);
        obj.write(text, strlen(text));
        obj.put((char)NULL);
        break;
      case '}' : // Message
        intext = 1;
        text = line+1;
        xor(text);
        obj.put((char)MessageOp);
        obj.write(text, strlen(text));
        obj.put((char)NULL);
        break;
      case '{' : // Mono-Space Message
        intext = 1;
        text = line+1;
        xor(text);
        obj.put((char)MSMessageOp);
        obj.write(text, strlen(text));
        obj.put((char)NULL);
        break;
      case ';' : case '`' : // Comment
        intext = 1;
        text = line+1;
        xor(text);
        obj.put((char)CommentOp);
        obj.write(text, strlen(text));
        obj.put((char)NULL);
        break;
      default :
        if (strlen(line))
        {
          intext = 1;
          text   = line;
          xor(text);
          obj.put((char)TextOp);
          obj.write(text, strlen(text));
          obj.put((char)NULL);
        } else
        {
          if (intext)
          {
            obj.put((char)TextOp);
            obj.put((char)NULL);
          } else
          {
            obj.put((char)BreakOp);
            obj.put((char)NULL);
          }
        }
        break;
    }
  }

  obj.put((char)NULL);
  int codesize = obj.tellp();

  delete[] name;
  delete[] code;
  delete[] line;

  return codesize;
}

int DeCompile(pObject o, char *dest)
{
  int DCP = 0, size, cmd, j;
  int DCS = o->codesize;
  short temp, temp2;
  char temps[40];
  char Prefix[] = {'@', '/', '>', '<', '#', ':', '|', ';', '!', '?', ']', '}', '{', '$'};

  ostrstream obj(dest, SCRATCH_SIZE);
  memset(dest, 0, SCRATCH_SIZE);
  if (!obj) return 0;

  while (DCP<DCS)
  {
    switch (o->code[DCP])
    {
      case ObjNameOp :
      case LabelOp :
      case ZapLabelOp :
      case CommentOp :
      case MoveOp :
      case PersgoOp :
      case CamOp :
      case BarkOp :
      case MessageOp :
      case MSMessageOp :
      case CenTextOp :
        obj.put((char)Prefix[o->code[DCP]-FirstOp]);
        DCP++;
        size = strlen(o->code + DCP);
        obj.write(o->code + DCP, size);
        DCP += size;
        obj.write("\n", 1);
        DCP++;
        break;
      case TextOp :
        DCP++;
        size = strlen(o->code + DCP);
        obj.write(o->code + DCP, size);
        DCP += size;
        obj.write("\n", 1);
        DCP++;
        break;
      case BreakOp :
        DCP += 2;
        obj.write("\n", 1);
        break;
      case CommandOp :
        DCP++;
        obj.put('#');
        cmd = o->code[DCP];
        size = strlen(commands[cmd]);
        obj.write(commands[cmd], size);
        DCP++;

        for (j=0; j<strlen(params[cmd]); j++)
        {
          switch (params[cmd][j])
          {
            case 'c' : // coords
              obj.put(' ');

              // x
              memcpy(&temp, o->code + DCP, sizeof(short));
              DCP += 2;
              ltoa(temp, temps, 10);
              obj.write(temps, strlen(temps));
              obj.put(',');

              // y
              memcpy(&temp, o->code + DCP, sizeof(short));
              DCP += 2;
              ltoa(temp, temps, 10);
              obj.write(temps, strlen(temps));

              // z
              memcpy(&temp, o->code + DCP, sizeof(short));
              DCP += 2;
              ltoa(temp, temps, 10);
              if (temps!=0)
              {
                obj.put(',');
                obj.write(temps, strlen(temps));
              }

/*
              obj.put(' ');

              memcpy(&temp, o->code + DCP, sizeof(short));
              DCP += 2;
              ltoa(temp, temps, 10);
              obj.write(temps, strlen(temps));
              obj.put(',');

              memcpy(&temp, o->code + DCP, sizeof(short));
              DCP += 2;
              ltoa(temp, temps, 10);
              obj.write(temps, strlen(temps));
*/
              break;
            case 'd' : // direction
              temp = o->code[DCP];
              if (temp>=0x20 && temp<0x40)
              {
                obj.write(" cw", 3);
                temp -= 0x20;
              }
              if (temp>=0x40 && temp<0x60)
              {
                obj.write(" ccw", 4);
                temp -= 0x40;
              }
              if (temp>=0x60 && temp<0x80)
              {
                obj.write(" opp", 4);
                temp -= 0x60;
              }
              if (temp>=0x80 && temp<0xA0)
              {
                obj.write(" rndp", 5);
                temp -= 0x80;
              }

              switch (temp)
              {
                case 0x01 : obj.write(" n", 2); break;
                case 0x02 : obj.write(" e", 2); break;
                case 0x03 : obj.write(" s", 2); break;
                case 0x04 : obj.write(" w", 2); break;
                case 0x0A : obj.write(" rnd", 4); break;
                case 0x0B : obj.write(" rndns", 6); break;
                case 0x0C : obj.write(" rndew", 6); break;
                case 0x0D : obj.write(" rndnb", 6); break;
                case 0x0E : obj.write(" rndb", 5); break;
                case 0x11 : obj.write(" flow", 5); break;
                case 0x12 : obj.write(" idle", 5); break;
              }
              DCP++;
              break;
            case 'e' : // operand
              switch (o->code[DCP])
              {
                case 0x01 : obj.write(" ==", 3); break;
                case 0x02 : obj.write(" !=", 3); break;
                case 0x03 : obj.write(" <=", 3); break;
                case 0x04 : obj.write(" >=", 3); break;
                case 0x05 : obj.write(" <", 2); break;
                case 0x06 : obj.write(" >", 2); break;
              }
              DCP++;
              break;
            case 'l' : // label
            case 'o' : // object name
            case 's' : // string
            case 'v' : // variable
              // get label
              obj.put(' ');
              size = strlen(o->code + DCP);
              obj.write(o->code + DCP, size);
              DCP += size + 1;
              break;
            case 'r' : // range
              obj.put(' ');
//            DCP += 4;
              break;
            case '#' : // number
              obj.put(' ');
              if (o->code[DCP]=='!')
              {
                size = strlen(o->code + DCP);
                obj.write(o->code + DCP, size);
                DCP += size + 1;
              } else
              {
                memcpy(&temp, o->code + DCP, sizeof(short));
                ltoa(temp, temps, 10);
                obj.write(temps, strlen(temps));
                DCP += 2;
              }
              break;
            case '1' : // number, def=1
              obj.put(' ');
              if (o->code[DCP]=='!')
              {
                size = strlen(o->code + DCP);
                obj.write(o->code + DCP, size);
                DCP += size + 1;
              } else
              {
                memcpy(&temp, o->code + DCP, sizeof(short));
                if (temp != 1)
                {
                  ltoa(temp, temps, 10);
                  obj.write(temps, strlen(temps));
                  DCP += 2;
                }
              }
              break;
          }
        }

        obj.put('\n');
        DCP++;
        break;
      default : DCP++; break;
    }
  }

  return 0;
}

short Hash(char *string)
{
  short val = 0;
  int hash_len = strlen(string)-1;
  for (int i=0; i<hash_len; i++)
  {
    val += (short)toupper(string[i]);
    val += (short)(toupper(string[i+1]) << 8);
  }
  return val;
}

short UniqueHash(char *string)
{
  short val = 0;
  int hash_len = strlen(string)-1;
  for (int i=0; i<hash_len; i++)
  {
    val += (short)string[i];
    val += (short)(string[i+1] << 8);
  }
  return val;
}

