// Defines some global defines and other things that the game
// programming library uses.

#ifndef __GLOBAL__
#define __GLOBAL__

//-- Universal Compatibility Defines ----------------------------------
// basics
#define U8  unsigned char
#define S8  signed char
#define U16 unsigned short
#define S16 signed short
#define U32 unsigned long
#define S32 signed long

#ifndef NULL
#define NULL 0L
#endif

// interrupts
#define INTERRUPT interrupt far

// convenience
#define string U8*
#define bool  U8
#define true  1
#define false 0

// commons
#define LO(a)  ((U8)((a) >> 8))
#define HI(a)  ((U8)(a))
#define WLO(a) ((U16)((a) >> 16))
#define WHI(a) ((U16)(a))

//-- Error Messages ---------------------------------------------------
#define HGL_ERROR   1
#define HGL_SUCCESS 0

enum ErrorCodes
{
  OK=0,

  FILE_FAIL,
  FILE_FILENOTFOUND,
  FILE_INVALIDPATH,
  FILE_TOOMANYFILES,
  FILE_INVFILEHANDLE,
  FILE_ACCESSDENIED,
  FILE_NOMEMORY,
  FILE_FILEEXISTS,

  DPMI_FAIL,
  DPMI_BADHEAP,
  DPMI_INVDESCRIPT,
  DPMI_NOMEMORY,

  NUMERRORCODES
};

#ifdef __cplusplus
extern "C" {
#endif

// Error variables
extern U16 hglError;
extern char *hglErrorStr[NUMERRORCODES];

void Error(char *str);

#ifdef __cplusplus
}
#endif

#endif
