#ifndef __ZZT_KERNEL__
#define __ZZT_KERNEL__

#include "global.h"
#include "tile.h"

extern Z2TileMap RoomData;

enum {
  CMD_NONE=0,
  CMD_ASK,
  CMD_BARKFONT,
  CMD_BARKCOLOR,
  CMD_BECOME,
  CMD_BIND,
  CMD_BREAKABLE,
  CMD_CAMXY,
  CMD_CAMFOCUS,
  CMD_CAMSHAKE,
  CMD_CAM,
  CMD_CEILING,
  CMD_CHANGE,
  CMD_COPYXY,
  CMD_COPY,
  CMD_CYCLEP,
  CMD_CYCLE,
  CMD_DECR,
  CMD_DEC,
  CMD_DIEITEM,
  CMD_DIE,
  CMD_DUPEXY,
  CMD_DUPE,
  CMD_ENDGAME,
  CMD_END,
  CMD_FADEIN,
  CMD_FADEOUT,
  CMD_FLOOR,
  CMD_FRAMEP,
  CMD_FRAME,
  CMD_GIVE,
  CMD_GOTO,
  CMD_GO,
  CMD_IDLE,
  CMD_IFXY,
  CMD_IFREL,
  CMD_IFNOTXY,
  CMD_IFNOTREL,
  CMD_IFANY,
  CMD_IFNO,
  CMD_IFALIGNEDNS,
  CMD_IFALIGNEDEW,
  CMD_IFALIGNED,
  CMD_IFBLOCKED,
  CMD_IFCONTACT,
  CMD_IFLASTSHOT,
  CMD_IFLASTTOUCH,
  CMD_IFSWIMMING,
  CMD_IFTOUCHING,
  CMD_IFWALKING,
  CMD_IF,
  CMD_INCR,
  CMD_INC,
  CMD_INPUT,
  CMD_LASER,
  CMD_LIGHTTORCH,
  CMD_LOCKPNS,
  CMD_LOCKPEW,
  CMD_LOCKPATTACK,
  CMD_LOCKP,
  CMD_LOCK,
  CMD_LOOP,
  CMD_MODFADEIN,
  CMD_MODFADEOUT,
  CMD_MODKILL,
  CMD_MODLOAD,
  CMD_MODNEXT,
  CMD_MODPAT,
  CMD_MODPREV,
  CMD_MODSTART,
  CMD_MODSTOP,
  CMD_MODVOLUME,
  CMD_MOVEXY,
  CMD_MOVE,
  CMD_MSGFONT,
  CMD_MSGCOLOR,
  CMD_MSGXY,
  CMD_OBJECT,
  CMD_PLAYFILE,
  CMD_PLAYKILL,
  CMD_PLAYLOAD,
  CMD_PLAYSET,
  CMD_PLAY,
  CMD_PUSHABLE,
  CMD_RESTART,
  CMD_RESTORE,
  CMD_ROTATECW,
  CMD_ROTATECCW,
  CMD_SENDRELP,
  CMD_SENDREL,
  CMD_SENDXY,
  CMD_SEND,
  CMD_SETR,
  CMD_SET,
  CMD_SHOOT,
  CMD_SOLID,
  CMD_SPAWNRELP,
  CMD_SPAWNXY,
  CMD_SPAWN,
  CMD_STRCMP,
  CMD_STRICMP,
  CMD_STRWORD,
  CMD_SWAPXY,
  CMD_SWAP,
  CMD_SWIMMERP,
  CMD_SWIMMER,
  CMD_TAKE,
  CMD_TELEPORTXY,
  CMD_TELEPORT,
  CMD_TILEUP,
  CMD_TILEDOWN,
  CMD_TILELEFT,
  CMD_TILERIGHT,
  CMD_TILEFLIPV,
  CMD_TILEFLIPH,
  CMD_TILEROTATEL,
  CMD_TILEROTATER,
  CMD_TRY,
  CMD_UNLOCKP,
  CMD_UNLOCK,
  CMD_WALK,
  CMD_ZAP,
};

#define BK_DEF  2
#define BK_BARK 1
#define BK_MSG  2
#define BK_MMSG 3
#define TM_DEF  30

#define GO_IDLE  0
#define GO_NORTH 1
#define GO_EAST  2
#define GO_SOUTH 3
#define GO_WEST  4
#define GO_UP    10
#define GO_DOWN  11

void zShiftUp(BITMAP &b);
void zShiftDown(BITMAP &b);
void zShiftLeft(BITMAP &b);
void zShiftRight(BITMAP &b);
void zFlip(BITMAP &b);
void zMirror(BITMAP &b);
void zRotateL(BITMAP &b);
void zRotateR(BITMAP &b);

int  UpdateObj(pObject o);
void Update(void);
int  SendMessage(pObject o, char *message);
int  SendMessage(pObject o, short hash);
int  SendMessage(char *roomname, char *objname, char *message);
int  SendSysMessage(char *objname, char *message);
int  SendHelpMessage(char *message);
int  Execute(pObject o);

short Play(pRoom r=NULL);
void InitGame(void);

#endif
