// Mouse Handler, version 1.2 -- Copyright 1996 Carlos DaSilva
// Version 1.0 -- First version
// Version 1.1 -- Added code and data locks, essential under VMMs
// Version 1.2 -- Added support for mouse button 3 (middle)

#ifndef __MOUSE__
#define __MOUSE__

#include "vgl.h"

typedef struct {
  unsigned mCode;
  unsigned mBut;
  signed   mDX, mDY;
  unsigned mX, mY;
} MOUSEDATA;

extern char MouseError[80];

int  m_Init(int w=80, int h=25, BITMAP *p=NULL);
void m_Done(void);
void m_Update(void);
int  m_SetPointer(BITMAP *p);
void m_SetHotspot(int x, int y);
int  m_inbounds(int x1, int y1, int x2, int y2);
int  m_Moved(void);
int  m_Left(void);
int  m_Right(void);
int  m_Middle(void);
int  m_X(void);
int  m_Y(void);
int  m_HardReset(void);
void m_Show(void);
void m_Hide(void);
void m_SetPos(int x, int y);
void m_SetBounds(int x1, int y1, int x2, int y2);
void m_SoftReset(void);

#endif
