// MultiKey, version 2.72 -- Copyright 1996 Carlos DaSilva
// Version 1.0 -- First version, 16-bit, in Turbo Pascal
// Version 1.5 -- First version, 16-bit, in Borland C
// Version 2.0 -- First version, 32-bit, in Watcom C
// Version 2.1 -- Added code and data locks, essential under VMMs
// Version 2.5 -- Correctly implemented extended keys, and Win95 keys
// Version 2.6 -- Correctly implemented Pause key, and differentiated
//                pad keys and inverted T keys
// Version 2.7 -- Added a method to obtain ASCII keys as if they were
//                typed with a BIOS handler installed.
// Version 2.71 - Fixed annoying bug (pressing special key caused handler
//                to eat next key)
// Version 2.72 - Added WasDown (check if a key was ever pressed)

#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <time.h>
#include <i86.h>
#include <dos.h>
#include "multikey.h"
#include "pmpro.h"
#include "vgl.h"

typedef struct {
  volatile char p60;
  volatile char kb[128];
  volatile char last;
  volatile char lastASCII;
  volatile char CapsLock;
  volatile char NumLock;
  volatile char ScrollLock;
} KBDATA;

volatile KBDATA kcbd;
void (interrupt far *PrevKey)();
char *kbBIOS = (char *) 0x417;
int HandlerInstalled;

static int KeyPadKeys[14] =
{mkHome, mkUp, mkPgUp, mkMinus, mkLeft, mkFive, mkRight,
 mkPlus, mkEnd, mkDown, mkPgDn, mkIns, mkDel, mkStar};

static char ASCIINames[] =
//0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F
{ 0,  27, '1','2','3','4','5','6','7','8','9','0','-','=',8,  9,     // 0
  'q','w','e','r','t','y','u','i','o','p','[',']',13, 0,  'a','s',   // 1
  'd','f','g','h','j','k','l',';',39, '`',0,  92, 'z','x','c','v',   // 2
  'b','n','m',',','.','/',0,  '*',0,  ' ',0,  200,201,202,203,204,   // 3
  205,206,207,208,209,0,  0,  '7','8','9','-','4','5','6','+','1',   // 4
  '2','3','0',127,210,211,0,  0,  0,  0,  0,  0,  0,  0,  0,  0,     // 5
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,     // 6
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0};    // 7

static char ShiftNames[] =
//0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F
{ 0,  27, '!','@','#','$','%','^','&','*','(',')','_','+',8,  9,     // 0
  'Q','W','E','R','T','Y','U','I','O','P','{','}',13, 0,  'A','S',   // 1
  'D','F','G','H','J','K','L',':',34, '~',0,  '|','Z','X','C','V',   // 2
  'B','N','M','<','>','?',0,  '*',0,  ' ',0,  0,  0,  0,  0,  0,     // 3
  0,  0,  0,  0,  0,  0,  0,  '7','8','9','-','4','5','6','+','1',   // 4
  '2','3','0',127,0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,     // 5
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,     // 6
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0};    // 7

static char SpecialNames[] =
//0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F
{ 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,     // 0
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  13, 0,  0,  0,     // 1
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,     // 2
  0,  0,  0,  0,  0,  '/',0,  0,  0,  0,  0,  0,  0,  0,  0,  0,     // 3
  0,  0,  0,  0,  0,  0,  0,  220,221,222,0,  224,0,  226,0,  228,   // 4
  229,230,231,232,0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,     // 5
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,     // 6
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0};    // 7

void interrupt far KeyHandler()
{
  char c=0;

  // Get scan code
  kcbd.last = kcbd.p60;
  kcbd.p60  = inp(0x60);

/*
  kcbd.kb[mkReboot] = ((kcbd.kb[mkLAlt] || kcbd.kb[mkRAlt]) &&
    (kcbd.kb[mkLCtrl] || kcbd.kb[mkRCtrl]) && kcbd.kb[mkDel]);
*/

  if (kcbd.p60 == 224)
  {} else
  if (kcbd.p60 == 225)
  {
    kcbd.kb[mkPause] = 1;
  } else
  if (kcbd.last == 224)
  {
    switch (kcbd.p60)
    {
      case mkLCtrl :
        kcbd.kb[mkLCtrl] = 1;
        break;
      case mkQuestion :
        kcbd.kb[mkQuestion] = 1;
        kcbd.kb[mkKeyPad] = 1;
        break;
      case mkLAlt :
        kcbd.kb[mkLAlt] = 1;
        break;
      case mkEnter :
        kcbd.kb[mkEnter] = 1;
        kcbd.kb[mkKeyPad] = 1;
        break;
      case mkHome : case mkUp : case mkPgUp : case mkLeft : case mkRight :
      case mkEnd : case mkDown : case mkPgDn : case mkIns : case mkDel :
        kcbd.kb[kcbd.p60] = 1;
        break;
    }
    switch (kcbd.p60)
    {
      case mkLCtrl+128    : kcbd.kb[mkLCtrl] = 0; break;
      case mkQuestion+128 :
        kcbd.kb[mkQuestion] = 0;
        kcbd.kb[mkKeyPad] = 0;
        break;
      case mkLAlt+128     : kcbd.kb[mkLAlt] = 0; break;
      case mkEnter+128    :
        kcbd.kb[mkEnter] = 0;
        kcbd.kb[mkKeyPad] = 0;
        break;
      case mkHome+128 : case mkUp+128 : case mkPgUp+128 : case mkLeft+128 :
      case mkRight+128 : case mkEnd+128 : case mkDown+128 : case mkPgDn+128 :
      case mkIns+128 : case mkDel+128 :
        kcbd.kb[kcbd.p60-128] = 0;
        break;
    }

    // if special key pressed, change c
    if (kcbd.p60 < 0x80) kcbd.lastASCII = SpecialNames[kcbd.p60];
  } else
  {
    kcbd.kb[mkKeyPad] = 0;
    for (int i=0; i<14; i++)
      if (kcbd.kb[KeyPadKeys[i]])
      {
        kcbd.kb[mkKeyPad] = 1;
        break;
      }

    if (kcbd.p60 >= 0x80)
    {
      kcbd.kb[kcbd.p60 & 0x7F] = 0;
    } else
    {
      kcbd.kb[kcbd.p60] = 1;

      if (kcbd.p60 == mkCapsLock) kcbd.CapsLock = !kcbd.CapsLock;
      if (kcbd.kb[mkLShift] || kcbd.kb[mkRShift])
      {
        c = ShiftNames[kcbd.p60];
        if ((c >= 'A') && (c <= 'Z') && kcbd.CapsLock)
          c += 'a' - 'A';
      } else
      {
        c = ASCIINames[kcbd.p60];
        if ((c >= 'a') && (c <= 'z') && kcbd.CapsLock)
          c -= 'a' - 'A';
      }
      if (c) kcbd.lastASCII = c;
    }
  }

  // Acknowledge the interrupt
  outp(0x20, 0x20);
}

void I9end(void) {}

void mk_Init(void)
{
  PM_lockDataPages((void*)KeyHandler, 256);
  PM_lockDataPages((void*)&kcbd, sizeof(KBDATA));
  PrevKey = _dos_getvect(0x9);
  _dos_setvect(0x9, KeyHandler);

  HandlerInstalled = 1;
  atexit(mk_Done);
}

void mk_Done(void)
{
  if (HandlerInstalled)
  {
    _dos_setvect(0x9, PrevKey);
    PM_unlockDataPages((void*)&kcbd, sizeof(KBDATA));
    PM_unlockDataPages((void*)KeyHandler, 256);

    HandlerInstalled = 0;
  }
}

int mk_Shift(void)
{
  return (kcbd.kb[mkRShift] || kcbd.kb[mkLShift]);
}

int mk_Ctrl(void)
{
  return (kcbd.kb[mkRCtrl] || kcbd.kb[mkLCtrl]);
}

int mk_Alt(void)
{
  return (kcbd.kb[mkLAlt] || kcbd.kb[mkRAlt]);
}

int mk_Shift(int key)
{
  return (kcbd.kb[mkRShift] || kcbd.kb[mkLShift]) && kcbd.kb[key];
}

int mk_Ctrl(int key)
{
  return (kcbd.kb[mkRCtrl] || kcbd.kb[mkLCtrl]) && kcbd.kb[key];
}

int mk_Alt(int key)
{
  return (kcbd.kb[mkLAlt] || kcbd.kb[mkRAlt]) && kcbd.kb[key];
}

int mk_Down(int key)
{
  return kcbd.kb[key];
}

int mk_PadDown(int key)
{
  return kcbd.kb[key] && kcbd.kb[mkKeyPad];
}

int mk_Pressed(int key)
{
  if (!kcbd.kb[key]) return 0;
  delay(10);
  kcbd.kb[key] = 0;

  return 1;
}

int mk_PadPressed(int key)
{
  if (!kcbd.kb[key] && !kcbd.kb[mkKeyPad]) return 0;
  delay(10);
  kcbd.kb[key] = 0;

  return 1;
}

void mk_Clear(void)
{
  memset((char *) kcbd.kb, 0, 128);
  kcbd.p60 = kcbd.lastASCII = 0;
}

int mk_LastKey(void)
{
  static lk=0;

  if (lk != kcbd.p60)
  {
    lk = kcbd.p60;
    return lk;
  }
  return 0;
}

void mk_Wait(int key)
{
  do {} while (!kcbd.kb[key]);
  mk_Clear();
}

char mk_ReadChar(void)
{
  char result;

  while (!(result = kcbd.lastASCII));
  kcbd.lastASCII = 0;
  return result;
}

char mk_PollChar(void)
{
  char result = kcbd.lastASCII;
  kcbd.lastASCII = 0;
  return result;
}

int mk_Hit(void)
{
  int a, i;

  for (a=0, i=0; i<128; i++)
    a += kcbd.kb[i];

  return a;
}
