#ifndef __ZZT_OBJECTS__
#define __ZZT_OBJECTS__

#include "global.h"
#include "editor.h"

extern pRoom   SystemRoom, GlobalRoom;
extern pRoom   RoomHead, RoomCur, StartRoom;
extern pVar    VarHead;
extern pObject LastObj, Z2Help;
extern char    DefName[80], DefFile[80], TileFile[80], SysRoom[80];

void InitEngine(void);
void DoneEngine(void);
void InitTiles(void);
int  LoadTiles(char *fn);
void KillTiles(void);
int  Compile(char *scrfile, char *dest);

int GetFrame(int t);
char *GetName(int t);

pObject FindObj(char *name, pObject head);
pObject FindObj(int hash, pObject head);
pItem   FindItem(char *name);
pItem   FindItem(short hash);
pItem   FindItemDesc(char *name);
pObject GetObjXY(int x, int y, pRoom r, int z=-1);
pObject AddObjXY(int x, int y, char *name, pRoom r, int z=L_OBJECT);
pObject AddObjXY(int x, int y, pObject Src, pRoom r, int z=L_OBJECT);
int     KillObjXY(int x, int y, pRoom r);
int     KillObjXY(int x, int y, pRoom r, int z);
pObject AddObj(char *objfile, pObject &head);
pObject AddItemObj(tItem &item, pObject &head);
pObject BindObj(pObject Src, pRoom r);
pObject BindObj(pObject Src, pObject &head);
pObject BindScroll(pObject Src, pRoom r);
pObject BindEmptyObj(pObject Src, pRoom r);
pObject CopyObj(char *name, pObject &head, pRoom r);
pObject CopyObj(pObject Src, pRoom r);
pObject CopyObj(pObject Src, pObject &head);
void    LoadObj(char *objfile, pObject o);
int     KillObj(pRoom r, pObject o);
int     sizeofObj(pObject o);
int     sizeofObjList(pObject head);

pVar    AddVar(char *name, short v=0, int ov=1);
pVar    FindVar(char *name);
int     FindVarVal(char *name);
int     KillVar(pVar v);
int     sizeofVar(pVar v);
int     sizeofVarList(void);

pObject AddGlobal(char *name);
int     KillGlobal(pObject o);

int     LoadWorld(char *fname);
int     SaveWorld(char *fname, char *desc);
pRoom   FindRoom(char *name);
pRoom   FindRoom(short hash);
pRoom   AddRoom(char *name, char *desc=NULL);
pRoom   InitRoom(char *name, char *desc=NULL);
int     LoadRoom(char *fname, pRoom r);
int     KillRoom(pRoom r);
void    KillRooms(void);
void    KillSystem(void);
int     sizeofRoom(pRoom r);
int     sizeofRoomList(void);
int     SaveRoom(char *fname, pRoom r);
pRoom   AddRoom(char *fname);

int     Spawn(char *name, int x, int y);

#endif
