// Palette Manager, version 2.0 -- Copyright 1996 Carlos DaSilva
// Version 1.0 -- First version
// Version 2.0 -- Rewritten with more powerful palette management functions

#ifndef __PAL__
#define __PAL__

#include <conio.h>

typedef char PALETTE[256][3];
typedef char INDEX[256];

#define BACKWARD 0
#define FORWARD  1

extern PALETTE VGA, Cur, Black, temp;
extern INDEX   Dark, Lite;
extern int Speed;

void pal_Init(void);
void pal_SetSpeed(int s);
int  pal_GetSpeed(void);
void pal_Load(char *f, PALETTE p);
void pal_Save(char *f, PALETTE p);
void pal_SetRGB(int c, char r, char g, char b);
void pal_GetRGB(int c, char *r, char *g, char *b);
void pal_SetCur(PALETTE p);
void pal_Set(PALETTE p, int f=0, int l=255);
void pal_Get(PALETTE *p);
char pal_FindColor(int r, int g, int b);
void pal_GetIndex(int r, int g, int b, INDEX p);
void pal_SetIntensity(PALETTE sp, PALETTE dp, int i, int f=0, int l=255);
void pal_CrossFade(PALETTE sp, PALETTE dp, int f=0, int l=255);
void pal_Rotate(int dir, int num, int f=0, int l=255);

#endif
