#ifndef __ZZT_SOUND__
#define __ZZT_SOUND__

#define EMPTYARRAY
#define NOEMS
#define NOMIDAS
#include "midas.h"

#define WAV_FREQ 22000

extern int zm_MixFreq;
extern int zm_DMABufSize;
extern int zm_Bits;
extern int zm_Mono;
extern int zm_Interp;
extern int zm_Device;
extern int zm_Channels;
extern int zm_Port, zm_IRQ, zm_DMA;

typedef struct tSound
{
  char name[21];
  int handle;
  int volume;
  int panning;
  int freq;
  int length;
  char *snd;
  struct tSound *next;
} Sound, *pSound;

extern pSound SoundHead, SoundCur;

void zm_SetDef(void);
int  zm_Init(void);
void zm_Done(void);
void zm_Update(void);

int  zm_modLoaded(void);
int  zm_modLoad(char *f);
void zm_modKill(void);
void zm_modStop(void);
void zm_modStart(void);
int  zm_modSize(void);
void zm_modNextPos(void);
void zm_modPrevPos(void);
void zm_modSetPos(int p);
char *zm_modSongName(void);
char *zm_modType(void);
char *zm_modPTLimits(void);
char *zm_modVolSlides(void);
char *zm_modOctaves(void);
char *zm_modFreqTable(void);
int  zm_modVolume(void);
void zm_modSetVolume(int v);
int  zm_modLooping(void);
void zm_modSetLooping(int l);

char *zm_cardName(void);
char *zm_cardDriver(void);
int  zm_cardInterp(void);
int  zm_cardBits(void);
int  zm_cardStereo(void);
int  zm_cardMixFreq(void);
int  zm_cardChannels(void);
int  zm_cardPort(void);
int  zm_cardDMA(void);
int  zm_cardIRQ(void);

pSound zm_wavFind(int handle);
pSound zm_wavAdd(char *wavfile, char *name=NULL);
void   zm_wavLoad(char *wavfile, pSound s);
int    zm_wavPlay(int handle);
int    zm_wavPlayCh(int handle, int v);
int    zm_wavFile(char *wavfile);
int    zm_wavPlayFX(int handle, int vol=64, int pan=0, int frq=WAV_FREQ);
int    zm_wavPlayChFX(int handle, int v, int vol=64, int pan=0, int frq=WAV_FREQ);
int    zm_wavFileFX(char *wavfile, int vol=64, int pan=0, int frq=WAV_FREQ);
int    zm_wavKill(pSound s);
int    zm_sizeofWav(pSound s);
int    zm_sizeofWavList(void);

int    zm_GetFreeVoice(void);

#endif
