// Sprite Manager, version 1.2 -- Copyright 1996 Carlos DaSilva
// Version 1.0 -- First version
// Version 1.1 -- Added provision for manually updated backgrounds (ie.
//                sprites can be instructed not to update themselves.)
// Version 1.2 -- Added special mouse sprite, which is always updated
//                last.

#ifndef __SPRITE__
#define __SPRITE__

#include "debug.h"
#include "vgl.h"

typedef struct {
  char   id[4];
  ushort w, h;
  ushort fr;
  char   *Data;
} SPRITE;

struct tSprite {
  int   x, y;
  int   ox, oy;
  short dx, dy;
  short w, h;
  short totfr;
  short curfr;
  char  loop;
  char  hidden;
  char  update;
  BITMAP *Spr;
  struct tSprite *next;
};

typedef struct tSprite Sprite;
typedef Sprite *pSprite;

extern pSprite SpriteHead, SpriteTail, SpriteList;
extern pSprite MousePtr;
extern int     SprPage;

void    s_Init(void);
int     s_InitPage(void);
int     s_Load(char *f, SPRITE &spr);
pSprite s_Add(SPRITE &spr);
pSprite s_Add(BITMAP &b);
pSprite s_AddMouse(BITMAP &b);
void    s_Update(int bg);

void    s_SetPos(pSprite spr, int x, int y);
void    s_SetMove(pSprite spr, int dx, int dy);
void    s_SetFrame(pSprite spr, int f);
void    s_SetLoop(pSprite spr, int l);
void    s_Hide(pSprite spr);
void    s_Show(pSprite spr);

#endif
