#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>

#define ushort unsigned short
#define ulong  unsigned long

typedef struct
{
  ushort x, y;
  char   bpp;
  union {
    char   *Data;
    ushort *Data16;
    ulong  *Data32;
  };
} BITMAP;

BITMAP in[512];
char id[] = "SPR1";

int g_LoadBitmap(char *f, BITMAP *b)
{
  ifstream fp;
  int i, s, total, cur;

  fp.open(f, ios::in | ios::binary);
  if (!fp) return 0;

  fp.seekg(0, ios::end);
  total = fp.tellg();
  fp.seekg(0, ios::beg);

  for (i=0, cur=0; cur<total; i++)
  {
    fp.read((unsigned char *)&b[i].x, sizeof(short));
    fp.read((unsigned char *)&b[i].y, sizeof(short));
    s = b[i].x * b[i].y;
    b[i].Data = new char[s];
    if (!b[i].Data)
    {
      cout << "Insufficient memory for bitmap " << f << " at index " << i << ".\n";
      exit(1);
    }
    fp.read(b[i].Data, s);
    cur += s+4;
  }

  fp.close();
  return i;
}

void main(void)
{
  short num = g_LoadBitmap("temp.vsp", in);

  ofstream fp;

  fp.open("temp.spr", ios::out | ios::binary);
  fp.write(id, 4);
  fp.write((unsigned char *)&in[0].x, sizeof(short));
  fp.write((unsigned char *)&in[0].y, sizeof(short));

  int Size = in[0].x * in[0].y;

  fp.write((unsigned char *)&num, sizeof(short));
  for (int i=0; i<num; i++)
    fp.write(in[i].Data, Size);

  fp.close();
}
